> ## Documentation Index
> Fetch the complete documentation index at: https://docs.semgrep.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# List Automations

> List all automations with pagination support.



## OpenAPI

````yaml /public_v2.openapi.yaml get /api/v2/deployments/{deploymentId}/automations
openapi: 3.0.3
info:
  title: Semgrep API
  description: >-
    The API v2 is currently a work in progress as we expand and improve our
    platform capabilities. There are no current plans to deprecate the [v1
    API](/api/v1/docs) – we remain committed to supporting existing integrations
    and will ensure that all v1 use cases are fully supported in v2 before any
    deprecation occurs.

    ## API Maturity Levels


    Each endpoint in the v2 API is marked with a maturity badge to help you
    understand its current state:


    🚧 **Experimental** - Use at your own risk. This endpoint was not originally
    designed for third-party use or is under active development. Expect
    significant breaking changes.


    ⚠️ **Beta** - This endpoint is being refined. We will communicate breaking
    changes to Beta partners as we tweak the implementation.


    ✅ **Stable** - No breaking changes will be made to this API. You can
    confidently build production integrations against these endpoints.


    We recommend using Stable endpoints for production applications and treating
    Experimental/Beta endpoints as previews of upcoming functionality. This API
    is documented in the **OpenAPI format**.


    # Authentication


    The API supports authentication with an API token with the "Web API"
    permission, without limited scopes of access.


    You can provision an API token [from the Settings
    page](https://semgrep.dev/orgs/-/settings/tokens).


    # Terms of Use


    Please note, the materials made available herein are subject to the [Semgrep
    Terms of Use](https://semgrep.dev/resources/website-terms/), and your access
    or use of any of the same is your acknowledgment and acceptance of the such
    terms.


    <br>


    ___
  contact:
    email: support@semgrep.com
  version: v2.0.0.alpha
  x-logo:
    url: https://semgrep.dev/images/SemgrepLogoWithTextWithMargin.svg
    backgroundColor: '#fafafa'
    altText: Semgrep logo
servers: []
security: []
tags:
  - name: AiFixJobsService
    description: Manage AI fix jobs for automated security fixes
    x-displayName: AI Fix Jobs
    x-group: AI Fix Jobs
  - name: AiTasksService
    description: Manage AI tasks, such as triage, auto-triage, and issue tagging backfill
    x-displayName: Ai Tasks
    x-group: Ai Tasks
  - name: AutofixService
    description: Trigger automated fixes for SAST, AI SAST, and SCA issues.
    x-displayName: Autofix
    x-group: Autofix
  - name: AutomationsService
    description: >-
      Automations are a way to automatically take actions on findings based on
      certain conditions.
    x-displayName: Automations
    x-group: Automations
  - name: AutotriageFeedbackService
    description: Feedback for the quality of autotriage, guidance or autofix
    x-displayName: Autotriage Feedback
    x-group: Autotriage Feedback
  - name: ChecklistService
    description: Manage onboarding checklist
    x-displayName: Onboarding Checklist
    x-group: Onboarding Checklist
  - name: DeploymentProductsService
    description: Manage deployment product configurations.
    x-displayName: Deployment Products
    x-group: Deployment Products
  - name: DeploymentService
    description: Manage deployment and its resources.
    x-displayName: Deployment
    x-group: Deployment
  - name: DeploymentSsoProvidersService
    description: Manage Deployment SSO Providers
    x-displayName: Deployment SSO Providers
    x-group: Deployment SSO Providers
  - name: DeploymentTagService
    description: Assign tags to a deployment.
    x-displayName: Deployment Tags
    x-group: Deployment Tags
  - name: DeploymentsService
    description: >-
      Deployments encapsulate your organization's security organization, with
      multiple projects, policies, and integrations. As the root object of the
      organization, they're similarly the root object of the API.
    x-displayName: Deployments
    x-group: Deployments
  - name: EditorService
    description: Run Semgrep patterns against target code in the editor playground
    x-displayName: Editor
    x-group: Editor
  - name: ExternalTicketingService
    description: APIs that power the External Ticketing experience.
    x-displayName: External Ticketing
    x-group: External Ticketing
  - name: FeatureRolloutsService
    description: View feature flags rolled out to all deployments
    x-displayName: Feature Rollouts
    x-group: Feature Rollouts
  - name: IgnoresService
    description: >-
      API for managing global ignores. See
      https://semgrep.dev/docs/ignoring-files-folders-code
    x-displayName: Global Ignores
    x-group: Global Ignores
  - name: InfrastructureConfigurationsService
    description: Infrastructure configuration information.
    x-displayName: Infrastructure Configurations
    x-group: Infrastructure Configurations
  - name: IssuesService
    description: Manage findings found by Semgrep scans
    x-displayName: Issues
    x-group: Issues
  - name: ManagedScanSettingsService
    description: Settings that affect all of a deployment's managed scans
    x-displayName: Managed Scan Settings
    x-group: Managed Scan Settings
  - name: MemoriesService
    description: Memories help reduce noise from findings.
    x-displayName: Memories
    x-group: Memories
  - name: MiscService
    description: Miscellaneous endpoints
    x-displayName: Misc
    x-group: Misc
  - name: NotificationRulesService
    description: Setup rules to get notified about new findings
    x-displayName: Notification Rules
    x-group: Notification Rules
  - name: NotificationWebhooksService
    description: Manage webhook endpoints for deployment notifications.
    x-displayName: Notification Webhooks
    x-group: Notification Webhooks
  - name: NotificationsService
    description: Notifications show in-app toasts to users.
    x-displayName: Notifications
    x-group: Notifications
  - name: PoliciesService
    description: >-
      View and manage the Policies of your organization.


      Deployments on the Unified Policies model use the [Policies V2
      API](/api/v2/docs/#tag/PoliciesV2Service) instead; this service stops
      working after the migration.
    x-displayName: Policies
    x-group: Policies
  - name: PoliciesV2Service
    description: >-
      Declarative management of detection and remediation policies for
      deployments on the Unified Policies model. Designed for GitOps-style
      reconciliation: read the current bundle, edit it, preview the diff with a
      dry run, then apply it strictly with optimistic concurrency control.
    x-displayName: Policies V2
    x-group: Policies V2
  - name: ProjectManagedScanSettingsService
    description: Settings that affect a specific project's managed scans
    x-displayName: Projects – Managed Scan Settings
    x-group: Projects – Managed Scan Settings
  - name: ProjectsService
    description: >-
      Projects are groups of files that are scanned by Semgrep. These normally
      correspond to repositories.
    x-displayName: Projects
    x-group: Projects
  - name: ReportsService
    description: APIs for Reporting Dashboards
    x-displayName: Reporting
    x-group: Reporting
  - name: ReviewCommentProductContentService
    description: >-
      Review comment product content is a way to add additional per-product
      information to a review comment.
    x-displayName: Review Comment Product Content
    x-group: Review Comment Product Content
  - name: RuleboardService
    description: >-
      The [Policies API](/api/v2/docs/#tag/PoliciesService) is *strongly*
      recommended. It is also newer than this Ruleboard service. Deployments on
      the Unified Policies model use the [Policies V2
      API](/api/v2/docs/#tag/PoliciesV2Service) instead; this service stops
      working after the migration.


      Manage Ruleboards (sets of policies).
    x-displayName: Ruleboards
    x-group: Ruleboards
  - name: ScansService
    description: View details of scans associated with projects in your organization.
    x-displayName: Scans
    x-group: Scans
  - name: ScmAppsService
    description: >-
      Manage connections to source code management systems (Github, Gitlab,
      etc.)
    x-displayName: Source Code Management (SCM) App
    x-group: Source Code Management (SCM) App
  - name: ScmService
    description: >-
      Manage connections to source code management systems (Github, Gitlab,
      etc.)
    x-displayName: Source Code Management (SCM) Configs
    x-group: Source Code Management (SCM) Configs
  - name: ScmSubscriptionsService
    description: Manage SCM Webhook Subscriptions
    x-displayName: Source Code Management (SCM) Webhooks
    x-group: Source Code Management (SCM) Webhooks
  - name: SlackService
  - name: SmsPackageManagerConfigService
    description: >-
      Manage authentication configurations for package managers used in Supply
      Chain Analysis (SCA) scans.
    x-displayName: Supply Chain - SMS Package Manager Configurations
    x-group: Supply Chain - SMS Package Manager Configurations
  - name: SmsScaResolutionConfigService
    description: >-
      Retrieve custom dependency resolution configurations for lockfileless
      scans.
    x-displayName: Supply Chain - SMS SCA Resolution Configurations
    x-group: Supply Chain - SMS SCA Resolution Configurations
  - name: SupplyChain2Service
    description: >-
      The Supply Chain is all of the dependencies of code, rather than the code
      itself. This service gives information about the supply chain.
    x-displayName: Supply Chain
    x-group: Supply Chain
  - name: SupportService
    description: Create and List Support Cases
    x-displayName: Support Service
    x-group: Support Service
  - name: SurveysService
    description: Retrieve and submit company surveys
    x-displayName: Surveys
    x-group: Surveys
  - name: TasksService
    description: >-
      Many tasks are done asynchronously; this service deals with managing async
      tasks.
    x-displayName: Tasks
    x-group: Tasks
  - name: TeamsService
    description: >-
      Teams are used to manage access control for resources within a deployment.
      For more information visit https://semgrep.dev/docs/deployment/teams.
    x-displayName: Teams
    x-group: Teams
  - name: TokenService
    description: >-
      Tokens are used for programmatic access to the Semgrep Cloud Platform
      APIs.
    x-displayName: Tokens
    x-group: Tokens
  - name: UsersService
    description: Manage user accounts, settings, and organization memberships
    x-displayName: Users Auth Service
    x-group: Users Auth Service
  - name: VersionsService
    description: Semgrep version information
    x-displayName: Versions
    x-group: Versions
  - name: WizCredentialService
    description: Manage Wiz credentials
    x-displayName: Wiz Credentials
    x-group: Wiz Credentials
paths:
  /api/v2/deployments/{deploymentId}/automations:
    get:
      tags:
        - AutomationsService
      summary: List Automations
      description: List all automations with pagination support.
      operationId: AutomationsService_ListAutomations
      parameters:
        - name: deploymentId
          in: path
          required: true
          schema:
            type: string
        - name: cursor
          in: query
          schema:
            type: string
        - name: limit
          in: query
          schema:
            type: integer
            format: int64
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/protos.automations.v2.ListAutomationsResponse
      security:
        - SemgrepWebToken: []
        - SemgrepJWT: []
components:
  schemas:
    protos.automations.v2.ListAutomationsResponse:
      type: object
      properties:
        automations:
          type: array
          items:
            $ref: '#/components/schemas/protos.automations.v1.Automation'
        cursor:
          type: string
    protos.automations.v1.Automation:
      type: object
      properties:
        filters:
          allOf:
            - $ref: '#/components/schemas/protos.automations.v1.Filters'
          description: Filters to apply to the automation
        actions:
          type: array
          items:
            $ref: '#/components/schemas/protos.automations.v1.Action'
          description: Actions to take when the automation is triggered
        active:
          type: boolean
          description: Whether the automation is enabled / disabled
        name:
          type: string
          description: Name of the automation
        description:
          type: string
          description: Description of the automation
        createdBy:
          type: string
          description: User who created the automation
        createdAt:
          type: string
          description: Timestamp when the automation was created
          format: date-time
        updatedAt:
          type: string
          description: Timestamp when the automation was last updated
          format: date-time
        id:
          type: string
          description: Unique identifier for the automation
        updatedBy:
          type: string
          description: User who last updated the automation
        internalOnly:
          type: boolean
          description: Whether the automation is internal only (e.g. Wiz action type)
        triggerSource:
          enum:
            - TRIGGER_SOURCE_SCAN
            - TRIGGER_SOURCE_AI_ANALYSIS
            - TRIGGER_SOURCE_MANUAL
            - TRIGGER_SOURCE_SUPPLY_CHAIN_INCIDENT
            - TRIGGER_SOURCE_WORKFLOW
            - TRIGGER_SOURCE_ISSUE_TRIAGED
          type: string
          description: >+
            Trigger source for the automation — determines when its actions
            fire.
             Most automations are scan-based; supply_chain_incident automations fire
             in response to a declared malware incident rather than a scan completion.

            | value | description |

            |-------|---------------|

            | TRIGGER_SOURCE_SCAN |  |

            | TRIGGER_SOURCE_AI_ANALYSIS |  |

            | TRIGGER_SOURCE_MANUAL |  |

            | TRIGGER_SOURCE_SUPPLY_CHAIN_INCIDENT |  |

            | TRIGGER_SOURCE_WORKFLOW |  |

            | TRIGGER_SOURCE_ISSUE_TRIAGED |  |

          format: enum
    protos.automations.v1.Filters:
      type: object
      properties:
        mode:
          enum:
            - MODE_ALL
            - MODE_ANY
            - MODE_NONE
            - MODE_UNKNOWN
          type: string
          description: |+

            | value | description |
            |-------|---------------|
            | MODE_ALL |  |
            | MODE_ANY |  |
            | MODE_NONE |  |
            | MODE_UNKNOWN |  |

          format: enum
        conditions:
          type: array
          items:
            $ref: '#/components/schemas/protos.automations.v1.Condition'
          description: Conditions to apply to the automation filtering
    protos.automations.v1.Action:
      type: object
      properties:
        type:
          enum:
            - ACTION_TYPE_BLOCK
            - ACTION_TYPE_PR_COMMENT
            - ACTION_TYPE_JIRA
            - ACTION_TYPE_SLACK_APP
            - ACTION_TYPE_EMAIL
            - ACTION_TYPE_WEBHOOK
            - ACTION_TYPE_SLACK_WEBHOOK
            - ACTION_TYPE_S3
            - ACTION_TYPE_UNKNOWN
            - ACTION_TYPE_WIZ
            - ACTION_TYPE_TRIAGE
            - ACTION_TYPE_DEVELOPER_EXCEPTION_REQUESTS
          type: string
          description: |+

            | value | description |
            |-------|---------------|
            | ACTION_TYPE_BLOCK |  |
            | ACTION_TYPE_PR_COMMENT |  |
            | ACTION_TYPE_JIRA |  |
            | ACTION_TYPE_SLACK_APP |  |
            | ACTION_TYPE_EMAIL |  |
            | ACTION_TYPE_WEBHOOK |  |
            | ACTION_TYPE_SLACK_WEBHOOK |  |
            | ACTION_TYPE_S3 |  |
            | ACTION_TYPE_UNKNOWN |  |
            | ACTION_TYPE_WIZ |  |
            | ACTION_TYPE_TRIAGE |  |
            | ACTION_TYPE_DEVELOPER_EXCEPTION_REQUESTS |  |

          format: enum
        config:
          type: object
          additionalProperties:
            type: string
    protos.automations.v1.Condition:
      type: object
      properties:
        mode:
          enum:
            - MODE_ALL
            - MODE_ANY
            - MODE_NONE
            - MODE_UNKNOWN
          type: string
          description: |+

            | value | description |
            |-------|---------------|
            | MODE_ALL |  |
            | MODE_ANY |  |
            | MODE_NONE |  |
            | MODE_UNKNOWN |  |

          format: enum
        type:
          enum:
            - CONDITION_TYPE_REPOSITORY_ID
            - CONDITION_TYPE_REPOSITORY_TAG_ID
            - CONDITION_TYPE_PRIMARY_REF
            - CONDITION_TYPE_PATH
            - CONDITION_TYPE_REF
            - CONDITION_TYPE_SEVERITY
            - CONDITION_TYPE_CONFIDENCE
            - CONDITION_TYPE_PRODUCT
            - CONDITION_TYPE_POLICY
            - CONDITION_TYPE_REACHABILITY
            - CONDITION_TYPE_TRANSITIVITY
            - CONDITION_TYPE_UPGRADE_AVAILABILITY
            - CONDITION_TYPE_EPSS_CATEGORY
            - CONDITION_TYPE_VALIDATION_STATE
            - CONDITION_TYPE_CVE
            - CONDITION_TYPE_REPOSITORY_VISIBILITY
            - CONDITION_TYPE_SECRET_TYPE
            - CONDITION_TYPE_AI_VERDICT
            - CONDITION_TYPE_AI_TAG
            - CONDITION_TYPE_AGGREGATE_STATE
            - CONDITION_TYPE_HAS_EXTERNAL_TICKET
            - CONDITION_TYPE_VULNERABILITY_ID
            - CONDITION_TYPE_UNKNOWN
            - CONDITION_TYPE_MALICIOUS_DEPENDENCY
            - CONDITION_TYPE_RULE_ID
            - CONDITION_TYPE_RULESET_ID
            - CONDITION_TYPE_WORKFLOW_ID
            - CONDITION_TYPE_VULNERABILITY_CLASS
            - CONDITION_TYPE_TRIAGE_STATE
          type: string
          description: |+

            | value | description |
            |-------|---------------|
            | CONDITION_TYPE_REPOSITORY_ID |  |
            | CONDITION_TYPE_REPOSITORY_TAG_ID |  |
            | CONDITION_TYPE_PRIMARY_REF |  |
            | CONDITION_TYPE_PATH |  |
            | CONDITION_TYPE_REF |  |
            | CONDITION_TYPE_SEVERITY |  |
            | CONDITION_TYPE_CONFIDENCE |  |
            | CONDITION_TYPE_PRODUCT |  |
            | CONDITION_TYPE_POLICY |  |
            | CONDITION_TYPE_REACHABILITY |  |
            | CONDITION_TYPE_TRANSITIVITY |  |
            | CONDITION_TYPE_UPGRADE_AVAILABILITY |  |
            | CONDITION_TYPE_EPSS_CATEGORY |  |
            | CONDITION_TYPE_VALIDATION_STATE |  |
            | CONDITION_TYPE_CVE |  |
            | CONDITION_TYPE_REPOSITORY_VISIBILITY |  |
            | CONDITION_TYPE_SECRET_TYPE |  |
            | CONDITION_TYPE_AI_VERDICT |  |
            | CONDITION_TYPE_AI_TAG |  |
            | CONDITION_TYPE_AGGREGATE_STATE |  |
            | CONDITION_TYPE_HAS_EXTERNAL_TICKET |  |
            | CONDITION_TYPE_VULNERABILITY_ID |  |
            | CONDITION_TYPE_UNKNOWN |  |
            | CONDITION_TYPE_MALICIOUS_DEPENDENCY |  |
            | CONDITION_TYPE_RULE_ID |  |
            | CONDITION_TYPE_RULESET_ID |  |
            | CONDITION_TYPE_WORKFLOW_ID |  |
            | CONDITION_TYPE_VULNERABILITY_CLASS |  |
            | CONDITION_TYPE_TRIAGE_STATE |  |

          format: enum
        values:
          type: array
          items:
            type: string
  securitySchemes:
    SemgrepWebToken:
      type: http
      description: >-
        Get access to data with your API token. Example header:


        `Authorization: Bearer
        2991e2fb4b540fe75b8f90677b0b892b6314e4961cb001fe6eb452eee248a628`


        The token can be provisioned from the Tokens section in your Settings,
        and requires explicitly enabling `Web API` access.
      scheme: bearer
      bearerFormat: string
    SemgrepJWT:
      type: http
      description: Get access to data with your user's JSON Web Token.
      scheme: bearer
      bearerFormat: string

````